local E, L, V, P, G, _ = unpack(ElvUI); --Import: Engine, Locales, PrivateDB, ProfileDB, GlobalDB
local CCW = E:NewModule('CustomChannelWarning', 'AceEvent-3.0')

-- Default Options
P['CCW'] = {
	['customchannelSound'] = 'Whisper Alert',
}

--Information popups
E.PopupDialogs['CBPO'] = {
	text = L['PLUGIN_INFO'],
	button1 = OKAY,
	hasEditBox = true,
	editBoxWidth = 350,
	timeout = 0,
	whileDead = true,
	preferredIndex = 3,
	hideOnEscape = true,
	exclusive = true,
	OnShow = function(self)
		self.editBox:SetText("http://www.tukui.org/addons/index.php?act=view&id=62")
		self.editBox:HighlightText()
	end,
	EditBoxOnEnterPressed = function(self) self:GetParent():Hide() end,
	EditBoxOnEscapePressed = function(self) self:GetParent():Hide() end,
}

E.PopupDialogs['CBS'] = {
	text = L['PLUGIN_INFO'],
	button1 = OKAY,
	hasEditBox = true,
	editBoxWidth = 350,
	timeout = 0,
	whileDead = true,
	preferredIndex = 3,
	hideOnEscape = true,
	exclusive = true,
	OnShow = function(self)
		self.editBox:SetText("http://www.tukui.org/addons/index.php?act=view&id=36")
		self.editBox:HighlightText()
	end,
	EditBoxOnEnterPressed = function(self) self:GetParent():Hide() end,
	EditBoxOnEscapePressed = function(self) self:GetParent():Hide() end,
}

E.PopupDialogs['CCW'] = {
	text = L['PLUGIN_INFO'],
	button1 = OKAY,
	hasEditBox = true,
	editBoxWidth = 350,
	timeout = 0,
	whileDead = true,
	preferredIndex = 3,
	hideOnEscape = true,
	exclusive = true,
	OnShow = function(self)
		self.editBox:SetText("http://www.tukui.org/addons/index.php?act=view&id=85")
		self.editBox:HighlightText()
	end,
	EditBoxOnEnterPressed = function(self) self:GetParent():Hide() end,
	EditBoxOnEscapePressed = function(self) self:GetParent():Hide() end,
}

E.PopupDialogs['OEAB'] = {
	text = L['PLUGIN_INFO'],
	button1 = OKAY,
	hasEditBox = true,
	editBoxWidth = 350,
	timeout = 0,
	whileDead = true,
	preferredIndex = 3,
	hideOnEscape = true,
	exclusive = true,
	OnShow = function(self)
		self.editBox:SetText("http://www.tukui.org/addons/index.php?act=view&id=65")
		self.editBox:HighlightText()
	end,
	EditBoxOnEnterPressed = function(self) self:GetParent():Hide() end,
	EditBoxOnEscapePressed = function(self) self:GetParent():Hide() end,
}

E.PopupDialogs['VAT'] = {
	text = L['PLUGIN_INFO'],
	button1 = OKAY,
	hasEditBox = true,
	editBoxWidth = 350,
	timeout = 0,
	whileDead = true,
	preferredIndex = 3,
	hideOnEscape = true,
	exclusive = true,
	OnShow = function(self)
		self.editBox:SetText("http://www.tukui.org/addons/index.php?act=view&id=91")
		self.editBox:HighlightText()
	end,
	EditBoxOnEnterPressed = function(self) self:GetParent():Hide() end,
	EditBoxOnEscapePressed = function(self) self:GetParent():Hide() end,
}

function CCW:InsertOptions()
	--Plugin 'GroupHeader' with information about me and all my plugins
	if not E.Options.args.blazeplugins then
		E.Options.args.blazeplugins = {
			order = -2,
			type = 'group',
			name = 'Plugins (by Blazeflack)',
			args = {},
		}
		E.Options.args.blazeplugins.args.aboutHeader = {
			order = 1,
			type = 'header',
			name = L['About Blazeflack'],
		}
		E.Options.args.blazeplugins.args.aboutBody = {
			order = 2,
			type = 'description',
			fontSize = 'medium',
			name = L['BLAZE_DESC'],
		}
		E.Options.args.blazeplugins.args.pluginsHeader = {
			order = 3,
			type = 'header',
			name = L['List of Plugins for ElvUI made by Blazeflack'],
		}
		E.Options.args.blazeplugins.args.aboutCBPO = {
			order = 4,
			type = 'group',
			name = 'ElvUI_CastBarPowerOverlay',
			guiInline = true,
			args = {
				info = {
					order = 1,
					type = 'description',
					name = L['CBPO_DESC'],
				},
				url = {
					order = 2,
					type = 'execute',
					name = L['Click Me'],
					func = function() E:StaticPopup_Show('CBPO', 'ElvUI_CastBarPowerOverlay') end,
				},
			},
		}
		E.Options.args.blazeplugins.args.aboutCBS = {
			order = 5,
			type = 'group',
			name = 'ElvUI_CastBarSnap',
			guiInline = true,
			args = {
				info = {
					order = 1,
					type = 'description',
					name = L['CBS_DESC'],
				},
				url = {
					order = 2,
					type = 'execute',
					name = L['Click Me'],
					func = function() E:StaticPopup_Show('CBS', 'ElvUI_CastBarSnap') end,
				},
			},
		}
		E.Options.args.blazeplugins.args.aboutCCW = {
			order = 6,
			type = 'group',
			name = 'ElvUI_CustomChannelWarning',
			guiInline = true,
			args = {
				info = {
					order = 1,
					type = 'description',
					name = L['CCW_DESC'],
				},
				url = {
					order = 2,
					type = 'execute',
					name = L['Click Me'],
					func = function() E:StaticPopup_Show('CCW', 'ElvUI_CustomChannelWarning') end,
				},
			},
		}
		E.Options.args.blazeplugins.args.aboutOEAB = {
			order = 7,
			type = 'group',
			name = 'ElvUI_OneExtraActionBar',
			guiInline = true,
			args = {
				info = {
					order = 1,
					type = 'description',
					name = L['OEAB_DESC'],
				},
				url = {
					order = 2,
					type = 'execute',
					name = L['Click Me'],
					func = function() E:StaticPopup_Show('OEAB', 'ElvUI_OneExtraActionBar') end,
				},
			},
		}
		E.Options.args.blazeplugins.args.aboutVAT = {
			order = 8,
			type = 'group',
			name = 'ElvUI_VisualAuraTimers',
			guiInline = true,
			args = {
				info = {
					order = 1,
					type = 'description',
					name = L['VAT_DESC'],
				},
				url = {
					order = 2,
					type = 'execute',
					name = L['Click Me'],
					func = function() E:StaticPopup_Show('VAT', 'ElvUI_VisualAuraTimers') end,
				},
			},
		}
	end
--
--	Insertion of ElvUI_CustomChannelWarning options starts here
--
	E.Options.args.blazeplugins.args.CCW = {
		order = 30,
		type = 'group',
		name = 'CustomChannelWarning',
		args = {
			customchannelSound = {
				order = 1,
				type = 'select',
				dialogControl = 'LSM30_Sound',
				name = L['Custom Channel Alert'],
				values = AceGUIWidgetLSMlists.sound,
				get = function(info) return E.db.CCW.customchannelSound end,
				set = function(info, value) E.db.CCW.customchannelSound = value; end,
			},
		},
	}
end

E:RegisterModule(CCW:GetName())